## Create filebacking
library("bigmemory")
x <- read.big.matrix("airline.csv", header = TRUE, 
   backingfile = "airline.bin", descriptorfile = "airline.desc", 
   type = "integer")
dim(x)

## Subsequent use
library("bigmemory")
x <- attach.big.matrix("airline.desc")
dim(x)
summary(x[, "DepDelay"])

## foreach framework
require("foreach")
x <- read.csv("1995.csv", as.is = TRUE)
groups <- split(1:nrow(x), x[, "DayOfWeek"])
depDelayQuantiles <- foreach(g = groups, .combine = rbind) %dopar% {
  quantile(x[g, "DepDelay"], probs = c(0.5, 0.9, 0.99), 
    na.rm = TRUE) 
}
rownames(depDelayQuantiles) <- c("Mon", "Tues", "Wed", "Thu", "Fri", 
  "Sat", "Sun")
depDelayQuantiles

## Combining bigmemory and foreach
GetDepQuantiles <- function(rows, data) {
  quantile(data[rows, "DepDelay"], probs = c(0.5, 0.9, 0.99), 
  na.rm = TRUE)
}
library("bigmemory")
x <- attach.big.matrix("airline.desc")

library("foreach")
library("doSNOW")
cl <- makeSOCKcluster(rep("localhost", 4))
registerDoSNOW(cl)

xdesc <- describe(x)
G <- split(1:nrow(x), x[, "DayOfWeek"])

qs <- foreach(g = G, .combine = rbind) %dopar% {
  require("bigmemory")
  x <- attach.big.matrix(xdesc)
  GetDepQuantiles(g, x)
}
rownames(qs) <- c("Mon", "Tues", "Wed", "Thu", "Fri", "Sat",
  "Sun")
qs
