x <- read.csv("cpuscaling.csv")

pdf("cpuscaling.pdf", width = 8, height = 6)
plot(1:6, c(x$serial, x$serial[1]), ylim = c(-10, max(x$foreachs)), xlim = c(1, 6),
  xlab = "Processor Cores", ylab = "Time (in seconds)", type = "l", lwd = 3)
lines(2:6, x$mclapply, lty = 2, col = 2, lwd = 3)
lines(2:6, x$parLapply, lty = 3, col = 3, lwd = 3)
lines(2:6, x$foreachm, lty = 4, col = 4, lwd = 3)
lines(2:6, x$foreachs, lty = 5, col = 5, lwd = 3)
legend(1, 5, 
  legend = c("matrix and serial (1-processor only)", 
    "matrix and mclapply (multicore)",
    "matrix and parLapply (snow)",
    "big.matrix and foreach (multicore)",
    "big.matrix and foreach (snow)"),
  col = 1:5,
  lty = 1:5, lwd = 3)
dev.off()

pdf("memoryscaling.pdf", width = 8, height = 6)
x <- read.csv("fourcoretiming.csv")
sizes <- c(190.7, 381.5, 572.2, 762.9, 953.6)
plot(sizes, x$serial, ylim = c(0, 55),
  xlab = "Size (MB)", ylab = "Time (in seconds)", type = "l", lwd = 3)
lines(sizes, x$mclapply, lty = 2, col = 2, lwd = 3)
lines(sizes, x$parLapply, lty = 3, col = 3, lwd = 3)
lines(sizes, x$foreachm, lty = 4, col = 4, lwd = 3)
lines(sizes, x$foreachs, lty = 5, col = 5, lwd = 3)
legend(200, 55, 
  legend = c("matrix and serial (1-processor only)", 
    "matrix and mclapply (multicore)",
    "matrix and parLapply (snow)",
    "big.matrix and foreach (multicore)",
    "big.matrix and foreach (snow)"),
  col = 1:5,
  lty = 1:5, lwd = 3)
dev.off()


